
<? /*
$req = getRequests();
$tot = count($req);
$hrs = getConfig('site', 'logRequestsExpiry');
$cunts = [];
foreach ($req as $r) { $r[1] = \Avos\Utils\countryCode($r[1]); $r[1] == '' ? $cunts['Unknown']++ : (isset($cunts[$r[1]]) ? $cunts[$r[1]]++ : $cunts[$r[1]] = 1); }
arsort($cunts);
?> 
<h3><?= $tot ?> requests in the last <?= $hrs ?> hours</h3>
<p><?= implode(', ', array_map(function($k) use ($cunts, $tot) { return "$k " . (int)($cunts[$k] * 10000 / $tot)/100 . "%"; }, array_keys($cunts))); ?></p>
<!--<table>
<? $req = array_splice($req, 0, 1000); ?>
<? foreach ($req as $r): ?>
<tr>
<td><?= timeAgo($r[0]); ?></td>
<td><?= $r[1] ?></td>
<td><?= $r[2] ?></td>
<td><?= $r[3] ?></td>
<td><?= $r[4] ?></td>
<td><?= implode(', ', array_map(function($k) use ($r) { return "$k=" . $r[5][$k]; }, array_keys($r[5]))); ?></td>
</tr>
<? endforeach; */?>

<style>
    /*grafic*/
.country-labels {
  display: flex;
  flex-wrap: wrap;
  gap: 5px;
  margin-top: 10px;
}
.country-labels .label {
  color: white;
  padding: 5px 10px;
  border-radius: 5px;
  font-size: 14px;
  font-weight: bold;
  display: inline-block; 
}
.country-labels {
  display: flex;
  flex-wrap: wrap;
  gap: 10px;
  margin-top: 10px;
}

.country-label {
  padding: 5px 10px;
  border-radius: 15px;
  font-size: 14px;
  color: #fff;
  display: inline-block;
  text-align: center;
  transition: background-color 0.3s ease;
}

.country-label:hover {
  opacity: 0.8;
}

.chart-container {
 /* width: 80%;
  max-width: 400px;
  margin: 20px auto;*/
  padding: 20px;
  background-color: #fff;
  border-radius: 10px;
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
}

@media screen and (max-width: 768px) {
  .chart-container {
      width: 90%;
      max-width: 350px;
  }
}

.requests-container {
  display: grid;
  grid-template-columns: 1fr;
  gap: 20px;
  margin-top: 20px;
  padding: 0 20px;
}

.request-card {
  background-color: #fff;
  border-radius: 10px;
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
  padding: 15px;
  display: flex;
  flex-direction: column;
  gap: 10px;
}

.request-card h4 {
  font-size: 18px;
  margin: 0;
  color: #2c3e50;
}

.request-card p {
  font-size: 14px;
  color: #7f8c8d;
  margin: 0;
}

.table-container {
  width: 95%;
  margin: 20px auto;
  overflow-x: auto;
}

table {
  width: 100%;
  margin-top: 0px;
  border-collapse: collapse;
  background-color: #fff;
  border-radius: 10px;
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
}

table th, table td {
  padding: 12px;
  text-align: left;
  border: 1px solid #ddd;
}



table td {
    word-wrap: break-word; /* This will ensure long URLs break and wrap within the table cell */
    white-space: normal; /* Allow normal wrapping behavior */
  color: #2c3e50;
  font-size: 13px;
}

table tr:nth-child(even) td {
 
}

table tr:hover td {
  background-color: #bdc3c7;
}

.pagination {
  display: flex;
  justify-content: center;
  margin-top: 20px;
}

.pagination button {
  background-color: #2980b9;
  color: white;
  border: none;
  padding: 10px 15px;
  margin: 0 5px;
  cursor: pointer;
  font-size: 14px;
}

.pagination button:hover {
  background-color: #1d6b92;
}

.pagination button.disabled {
  background-color: #b0bec5;
  cursor: not-allowed;
}




/*grafic*/
</style>
<div class="container-fluid">


<script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
<script src="https://cdn.jsdelivr.net/npm/chartjs-plugin-datalabels"></script>

<?php 
$req = getRequests();
$tot = count($req);
$hrs = getConfig('site', 'logRequestsExpiry');
$cunts = [];

// Count requests by country
foreach ($req as $r) { 
    $r[1] = \Avos\Utils\countryCode($r[1]); 
    $r[1] == '' ? $cunts['Unknown']++ : (isset($cunts[$r[1]]) ? $cunts[$r[1]]++ : $cunts[$r[1]] = 1); 
}
arsort($cunts);
?>


<!-- Pie Chart -->
<div class="col-md-4 widget widget1" style="    height: 300px; width: 300px;">
<div class="chart-container">
    <canvas id="countryChart" width="200" height="200"></canvas>
    <pif class="widget-header">
    <h4 class="widget-title"><?= $tot ?> requests in the last <?= $hrs ?> hours</h4>
    <div class="country-labels">
        <?php
        $colors = [
            '#FF6384', '#36A2EB', '#FFCE56', '#4CAF50', '#FFC300', '#D1A1E0', '#FF5733',
            '#8E44AD', '#2ECC71', '#E74C3C', '#3498DB', '#F39C12', '#9B59B6', '#1ABC9C',
            '#D35400', '#C0392B', '#7D3C98', '#27AE60', '#2980B9', '#F1C40F', '#16A085',
            '#34495E', '#95A5A6', '#DFFF00', '#40E0D0', '#FF1493', '#B22222', '#00FF7F',
            '#FF4500', '#8B008B', '#4682B4', '#FFD700', '#DC143C', '#00CED1', '#FF69B4'
        ];

        $i = 0;
        foreach ($cunts as $country => $count) {
            $percentage = (int)($count * 10000 / $tot) / 100;
            $color = $colors[$i % count($colors)]; // Cycle through colors
            echo "<span class='label' style='background-color: $color;'>$country $percentage%</span> ";
            $i++;
        }
        ?>
    </div>
</pif> 
</div>




</div>
<!-- Pie Chart --> 

<!-- Requests in Cards -->
<div class="col-md-12 charts-grids widget states-mdl" style="">
<div class="table-container">
    
    <table id="requestsTable">
        
        <thead>
            <tr>
                <th>Time</th>
                <th>Country</th>
                <th>Request Type</th>
                <th>Details</th>
            </tr>
        </thead>
        <tbody>
            <?php $req = array_splice($req, 0, 1000); ?>
            <?php foreach ($req as $r): ?>
            <tr>
                <td><?= timeAgo($r[0]); ?></td>
                <td><?= $r[1] ?></td>
                <td><?php
    $currentDomain = 'https://' . $_SERVER['HTTP_HOST'];
    $url = $currentDomain . $r[2]; // Assuming $r[2] is the URL path
    echo "<a href=\"$url\" target=\"_blank\" title=\"$url\">" . htmlspecialchars(preg_replace('!(https://.+?/)!', '$1 ', $url)) . "</a>";
?></td>
                <td><?= implode(', ', array_map(function($k) use ($r) { return "$k=" . $r[5][$k]; }, array_keys($r[5]))); ?></td>
            </tr>
            <?php endforeach; ?>
        </tbody>
    </table>

    <div class="pagination">
        <button id="prevPage" class="disabled">Prev</button>
        <button id="nextPage">Next</button>
    </div>


<script>
// Pagination functionality 
let currentPage = 1;
const rowsPerPage = 50; // Change this number based on how many rows you want to display per page
const rows = document.querySelectorAll('#requestsTable tbody tr');
const totalRows = rows.length;
const totalPages = Math.ceil(totalRows / rowsPerPage);

function showPage(page) {
    // Show only rows for the current page
    const startIndex = (page - 1) * rowsPerPage;
    const endIndex = page * rowsPerPage;

    rows.forEach((row, index) => {
        if (index >= startIndex && index < endIndex) {
            row.style.display = '';
        } else {
            row.style.display = 'none';
        }
    });

    // Update button states
    document.getElementById('prevPage').classList.toggle('disabled', page === 1);
    document.getElementById('nextPage').classList.toggle('disabled', page === totalPages);
}

document.getElementById('prevPage').addEventListener('click', () => {
    if (currentPage > 1) {
        currentPage--;
        showPage(currentPage);
    }
});

document.getElementById('nextPage').addEventListener('click', () => {
    if (currentPage < totalPages) {
        currentPage++;
        showPage(currentPage);
    }
});

// Initial page load
showPage(currentPage);

// Prepare the data for Chart.js
const chartData = <?php echo json_encode(array_map(function($country, $count) use ($tot) {
    return ['country' => $country, 'percentage' => ($count / $tot) * 100];
}, array_keys($cunts), $cunts)); ?>;

console.log(chartData); // Check the data output in console

if (chartData.length > 0) {
    const labels = chartData.map(item => item.country);
    const data = chartData.map(item => item.percentage);

    const ctx = document.getElementById('countryChart').getContext('2d');
    new Chart(ctx, {
        type: 'pie',
        data: {
            labels: labels,
            datasets: [{
                data: data,
                backgroundColor: [
    '#FF6384', '#36A2EB', '#FFCE56', '#4CAF50', '#FFC300', '#D1A1E0', '#FF5733',
    '#8E44AD', '#2ECC71', '#E74C3C', '#3498DB', '#F39C12', '#9B59B6', '#1ABC9C',
    '#D35400', '#C0392B', '#7D3C98', '#27AE60', '#2980B9', '#F1C40F', '#16A085',
    '#34495E', '#95A5A6', '#DFFF00', '#40E0D0', '#FF1493', '#B22222', '#00FF7F',
    '#FF4500', '#8B008B', '#4682B4', '#FFD700', '#DC143C', '#00CED1', '#FF69B4'
],
                hoverOffset: 4
            }]
        },
        options: {
            responsive: true,
            plugins: {
                legend: {
                    position: 'top',
                },
                tooltip: {
                    callbacks: {
                        label: function(tooltipItem) {
                            return tooltipItem.label + ': ' + tooltipItem.raw.toFixed(2) + '%';
                        }
                    }
                }
            }
        }
    });
} else {
    alert("No data to display in chart.");
}
</script>

</div>
</div>
</div>
